<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Overview</title>
    <detaileddescription>
<para>This library provides a set of APIs that can be used to establish and monitor Wi-Fi connections on Cypress platforms that support Wi-Fi connectivity. WCM library APIs are easy to use; in addition, the library provides additional features such Wi-Fi Protected Setup (WPS) and connection monitoring.</para>
<para><heading level="1">Features and Functionality</heading></para>
<para>The current implementation has the following features and functionality:<itemizedlist>
<listitem><para>Supports only STA mode. AP and Concurrent AP + STA modes will be added in the future.</para></listitem><listitem><para>Support for Wi-Fi Protected Setup (WPS) - Enrollee role.</para></listitem><listitem><para>Exposes Wi-Fi APIs to scan, join, and leave the Wi-Fi network.</para></listitem><listitem><para>Connection monitoring: Monitors active connection and link events. Automatically reconnects to the Wi-Fi AP if the connection with the AP is lost intermediately. Notifies connection state change through event notification registration mechanism.</para></listitem><listitem><para>Built on top of Cypress RTOS abstraction layer (which currently supports FreeRTOS), LwIP, and Mbed TLS (bundled as part of Wi-Fi Middleware Core Library).</para></listitem></itemizedlist>
</para>

<para><heading level="1">Supported Platforms</heading></para>
<para>This library and its features are supported on the following Cypress platforms:<itemizedlist>
<listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/psoc-6-wi-fi-bt-prototyping-kit-cy8cproto-062-4343w">PSoC 6 Wi-Fi BT Prototyping Kit (CY8CPROTO-062-4343W)</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/documentation/development-kitsboards/psoc-62s2-wi-fi-bt-pioneer-kit-cy8ckit-062s2-43012">PSoC 62S2 Wi-Fi BT Pioneer Kit (CY8CKIT-062S2-43012)</ulink></para></listitem></itemizedlist>
</para>

<para><heading level="1">Dependent Libraries</heading></para>
<para>This library includes <ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core">Wi-Fi middleware core</ulink> by default. It helps code examples to enable Wi-Fi connectivity components without having to include additional libraries. The Wi-Fi host driver library is part of the Wi-Fi middleware core.</para>

<para><heading level="1">Quick Start</heading></para>
<para><itemizedlist>
<listitem><para>A set of pre-defined configuration files have been bundled with the wifi-mw-core library for FreeRTOS, LwIP, and Mbed TLS. The developer is expected to review the configuration and make adjustments. See the Quick start section in <ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core/blob/master/README.md">README.md</ulink> for more details A set of COMPONENTS have to be defined in the code example project's Makefile for this library. Refer to the Quick start section in <ulink url="https://github.com/cypresssemiconductorco/wifi-mw-core/blob/master/README.md">README.md</ulink> for more details.</para></listitem><listitem><para>WCM library enables only error prints by default. For debugging purposes, the application may additionally enable debug and info log messages. To enable these messages, add the WCM_ENABLE_PRINT_INFO, WCM_ENABLE_PRINT_DEBUG, WPS_ENABLE_PRINT_INFO, and WPS_ENABLE_PRINT_DEBUG macros to the DEFINES in the code example's Makefile. The Makefile entry would look like as follows: <programlisting><codeline><highlight class="normal">DEFINES+=WCM_ENABLE_PRINT_INFO<sp />WCM_ENABLE_PRINT_DEBUG</highlight></codeline>
<codeline><highlight class="normal">DEFINES+=WPS_ENABLE_PRINT_INFO<sp />WPS_ENABLE_PRINT_DEBUG</highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Snippet 1: Scan for all Wi-Fi APs</bold></para>
<para>The following snippet demonstrates how to Initialize Wi-Fi device, network stack, and starts scanning for AP without any filters. The scan_callback receives the scan results and prints them over the serial terminal</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Scan<sp />callback<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />scan_callback(<ref kindref="compound" refid="structcy__wcm__scan__result__t">cy_wcm_scan_result_t</ref><sp />*result_ptr,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*user_data,<sp /><ref kindref="member" refid="group__group__wcm__enums_1ga24a4ed65a9261c45abc8aa697eb2b8a2">cy_wcm_scan_status_t</ref><sp />status)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Print<sp />the<sp />scan<sp />result<sp />only<sp />when<sp />scan<sp />is<sp />incomplete<sp />because<sp />on<sp />scan<sp />completion</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />the<sp />contents<sp />of<sp />result_ptr<sp />are<sp />empty.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga24a4ed65a9261c45abc8aa697eb2b8a2a01103577816da05a7b2b9521576c3c6e">CY_WCM_SCAN_INCOMPLETE</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"<sp />%-32s<sp /><sp /><sp /><sp /><sp />%4d<sp /><sp /><sp /><sp /><sp />%2d\n"</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result_ptr-&gt;<ref kindref="member" refid="structcy__wcm__scan__result__t_1adcf0e592c5ea946e9ce821b6a13262d4">SSID</ref>,<sp />result_ptr-&gt;<ref kindref="member" refid="structcy__wcm__scan__result__t_1ac2d508f92bd91a322db54d59f9c42ce5">signal_strength</ref>,<sp />result_ptr-&gt;<ref kindref="member" refid="structcy__wcm__scan__result__t_1a2c07eb8659b1c9e79cd41b141ab7a52d">channel</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_wcm_scan_without_filter()</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />Wi-Fi<sp />device<sp />as<sp />a<sp />STA.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__config__t">cy_wcm_config_t</ref><sp />config<sp />=<sp />{.<ref kindref="member" refid="structcy__wcm__config__t_1ab516902a377cf7b51d1965183c0bfc2f">interface</ref><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggac4c4ca6db8db6efdc3013b789a4c9cf8ae93c4aa9ce482c333a23bdc535df3208">CY_WCM_INTERFACE_TYPE_STA</ref>};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />Wi-Fi<sp />device,<sp />Wi-Fi<sp />transport,<sp />and<sp />lwIP<sp />network<sp />stack.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__wcm__functions_1ga888428a2325f131528f7447e894002eb">cy_wcm_init</ref>(&amp;config);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Filter<sp />is<sp />set<sp />to<sp />NULL.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__wcm__functions_1gae0f0b5f3e6138bfdae943e9f7b16aa07">cy_wcm_start_scan</ref>(scan_callback,<sp />NULL,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: Scan for a Specific Wi-Fi AP</bold></para>
<para>The following snippet demonstrates configuration of scan filter to filter by the SSID provided and starts a scan. The scan_callback receives the scan results and prints over the serial terminal</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_wcm_scan_with_ssid_filter()</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__scan__filter__t">cy_wcm_scan_filter_t</ref><sp />scan_filter;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />SSID<sp />value<sp />which<sp />is<sp />used<sp />to<sp />filter<sp />the<sp />scan<sp />results*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__wcm__typedefs_1ga1ebac1800928741a07555a14539f3748">cy_wcm_ssid_t</ref><sp />ssid<sp />=<sp /></highlight><highlight class="stringliteral">"SSID"</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />scan<sp />filter<sp />specified<sp />by<sp />the<sp />variable<sp />ssid.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />scan_filter.<ref kindref="member" refid="structcy__wcm__scan__filter__t_1a019063e2d7ac38f8123fa6181afc45b8">mode</ref><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga568b22d5d446e751f62efe4eb021d451ae6a7c2fd74a727b9d1f3e0261533a7c4">CY_WCM_SCAN_FILTER_TYPE_SSID</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memcpy(scan_filter.<ref kindref="member" refid="structcy__wcm__scan__filter__t_1a5c9dfdbc17237085973999b63d9b28e5">param</ref>.<ref kindref="member" refid="structcy__wcm__scan__filter__t_1ad8d3cb78527ac618f0a3994ac497cc35">SSID</ref>,<sp />ssid,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__wcm__typedefs_1ga1ebac1800928741a07555a14539f3748">cy_wcm_ssid_t</ref>));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"\n---------------------------------------------------------------------------------\n"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="stringliteral">"<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />SSID<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />RSSI<sp /><sp /><sp />Channel<sp /><sp /><sp /><sp /><sp /><sp />\n"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="stringliteral">"---------------------------------------------------------------------------------\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__wcm__functions_1gae0f0b5f3e6138bfdae943e9f7b16aa07">cy_wcm_start_scan</ref>(scan_callback,<sp />NULL,<sp />&amp;scan_filter);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>

<para><bold>Snippet 3: Connect to Wi-Fi AP</bold></para>
<para>This code snippet demonstrates scanning for WIFI_SSID to get the security type of the AP and then connects to it. After successful connection, the device registers an event callback through which the middleware notifies the application on disconnection, reconnection, and IP change events. If the connection to AP fails it is retried up to MAX_WIFI_RETRY_COUNT times before admitting failure</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Wi-Fi<sp />Credentials:<sp />Modify<sp />WIFI_SSID<sp />and<sp />WIFI_PASSWORD<sp />to<sp />match<sp />your<sp />Wi-Fi<sp />network</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />Credentials.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />WIFI_SSID<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"SSID"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />WIFI_PASSWORD<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />"PASSWORD"</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MAX_WIFI_RETRY_COUNT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(3u)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />WIFI_CONN_RETRY_INTERVAL_MSEC<sp /><sp /><sp /><sp /><sp /><sp /><sp />(100u)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />size<sp />of<sp />the<sp />cy_wcm_ip_address_t<sp />array<sp />that<sp />is<sp />passed<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />cy_wcm_get_ip_addr<sp />API.<sp />In<sp />the<sp />case<sp />of<sp />stand-alone<sp />AP<sp />or<sp />STA<sp />mode<sp />the<sp />size<sp />of</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />the<sp />array<sp />is<sp />1.<sp />In<sp />concurrent<sp />AP/STA<sp />mode<sp />the<sp />size<sp />of<sp />the<sp />array<sp />is<sp />2<sp />where</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />the<sp />first<sp />index<sp />stores<sp />the<sp />IP<sp />address<sp />f=of<sp />the<sp />STA<sp />and<sp />the<sp />second<sp />index</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />stores<sp />the<sp />IP<sp />address<sp />of<sp />the<sp />AP.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SIZE_OF_IP_ARRAY_STA<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1u)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Scan<sp />callback<sp />function<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />scan_to_get_security(<ref kindref="compound" refid="structcy__wcm__scan__result__t">cy_wcm_scan_result_t</ref><sp />*result_ptr,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*user_data,<sp /><ref kindref="member" refid="group__group__wcm__enums_1ga24a4ed65a9261c45abc8aa697eb2b8a2">cy_wcm_scan_status_t</ref><sp />status)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__wcm__enums_1ga8b22f5a47073d5219440566d0e53e521">cy_wcm_security_t</ref>*<sp />security<sp />=<sp />(<ref kindref="member" refid="group__group__wcm__enums_1ga8b22f5a47073d5219440566d0e53e521">cy_wcm_security_t</ref><sp />*)user_data;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scan<sp />for<sp />SSID<sp />and<sp />pass<sp />the<sp />security<sp />type<sp />through<sp />user_data.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((strlen((</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*)result_ptr-&gt;<ref kindref="member" refid="structcy__wcm__scan__result__t_1adcf0e592c5ea946e9ce821b6a13262d4">SSID</ref>)<sp />!=<sp />0)<sp />&amp;&amp;<sp />(status<sp />==<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga24a4ed65a9261c45abc8aa697eb2b8a2a01103577816da05a7b2b9521576c3c6e">CY_WCM_SCAN_INCOMPLETE</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*security<sp />=<sp />result_ptr-&gt;<ref kindref="member" refid="structcy__wcm__scan__result__t_1a0bdbcaaaab6950223ad759eb1315daf2">security</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />xTaskNotify(snippet_task_handle,<sp />0,<sp />eNoAction);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__wcm__functions_1ga5dee06ae6be65b7c3397204152fa8edf">cy_wcm_stop_scan</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />network_event_callback(<ref kindref="member" refid="group__group__wcm__enums_1gafada6a09a78bd0473f3daef54621567f">cy_wcm_event_t</ref><sp />event,<sp /><ref kindref="compound" refid="unioncy__wcm__event__data__t">cy_wcm_event_data_t</ref><sp />*event_data)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__wcm__enums_1ggafada6a09a78bd0473f3daef54621567fa206d74c35be5bf29e7903367287efc79">CY_WCM_EVENT_DISCONNECTED</ref><sp />==<sp />event)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"Disconnected<sp />from<sp />Wi-Fi\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__wcm__enums_1ggafada6a09a78bd0473f3daef54621567fab2e59655829c24bd5d0ea68622c8c56e">CY_WCM_EVENT_RECONNECTED</ref><sp />==<sp />event)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"Reconnected<sp />to<sp />Wi-Fi.\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />event<sp />corresponds<sp />to<sp />the<sp />event<sp />when<sp />the<sp />IP<sp />address<sp />of<sp />the<sp />device</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />changes.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__wcm__enums_1ggafada6a09a78bd0473f3daef54621567fafe83442aa63aa747c3025d0874482c86">CY_WCM_EVENT_IP_CHANGED</ref><sp />==<sp />event)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__ip__address__t">cy_wcm_ip_address_t</ref><sp />ip_addr;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__wcm__functions_1ga684ba6f1f1814d29775abaca9a029cd2">cy_wcm_get_ip_addr</ref>(<ref kindref="member" refid="group__group__wcm__enums_1ggac4c4ca6db8db6efdc3013b789a4c9cf8ae93c4aa9ce482c333a23bdc535df3208">CY_WCM_INTERFACE_TYPE_STA</ref>,<sp />&amp;ip_addr,<sp />SIZE_OF_IP_ARRAY_STA);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1a7c275791b147e4ccd77ad178dd25bf81">version</ref><sp />==<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga24d3def17207a3c64b62fb4b8a44a7fca579126d4304962b6ee0f286e5afcbe8a">CY_WCM_IP_VER_V4</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"IP<sp />Address:<sp />%d.%d.%d.%d\n"</highlight><highlight class="normal">,<sp />(uint8_t)event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1acabea09ec2785e76f7d867a74dd6afd7">v4</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint8_t)(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1acabea09ec2785e76f7d867a74dd6afd7">v4</ref><sp />&gt;&gt;<sp />8),<sp />(uint8_t)(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1acabea09ec2785e76f7d867a74dd6afd7">v4</ref><sp />&gt;&gt;<sp />16),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(uint8_t)(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1acabea09ec2785e76f7d867a74dd6afd7">v4</ref><sp />&gt;&gt;<sp />24));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1a7c275791b147e4ccd77ad178dd25bf81">version</ref><sp />==<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga24d3def17207a3c64b62fb4b8a44a7fcaa76a9ec3e0ee840982c8094f4416f768">CY_WCM_IP_VER_V6</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"IP<sp />Address:<sp />%lX:%lX:%lX:%lX\n"</highlight><highlight class="normal">,<sp />event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1a969244fd2e8b1da5fc07b75c4811e33c">v6</ref>[0],</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1a969244fd2e8b1da5fc07b75c4811e33c">v6</ref>[1]),<sp />(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1a969244fd2e8b1da5fc07b75c4811e33c">v6</ref>[2]),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(event_data-&gt;<ref kindref="member" refid="unioncy__wcm__event__data__t_1a9c8f9a98e351394d704d1796328ae466">ip_addr</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1ac5cf849d1ad2018fa370b60e13b0024c">ip</ref>.<ref kindref="member" refid="structcy__wcm__ip__address__t_1a969244fd2e8b1da5fc07b75c4811e33c">v6</ref>[3]));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_wcm_connect_ap()</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__connect__params__t">cy_wcm_connect_params_t</ref><sp />connect_param;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__ip__address__t">cy_wcm_ip_address_t</ref><sp />ip_address;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__wcm__enums_1ga8b22f5a47073d5219440566d0e53e521">cy_wcm_security_t</ref><sp />security;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__scan__filter__t">cy_wcm_scan_filter_t</ref><sp />scan_filter;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />scan<sp />filter<sp />specified<sp />by<sp />the<sp />macro<sp />WIFI_SSID.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />scan_filter.<ref kindref="member" refid="structcy__wcm__scan__filter__t_1a019063e2d7ac38f8123fa6181afc45b8">mode</ref><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga568b22d5d446e751f62efe4eb021d451ae6a7c2fd74a727b9d1f3e0261533a7c4">CY_WCM_SCAN_FILTER_TYPE_SSID</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memcpy(scan_filter.<ref kindref="member" refid="structcy__wcm__scan__filter__t_1a5c9dfdbc17237085973999b63d9b28e5">param</ref>.<ref kindref="member" refid="structcy__wcm__scan__filter__t_1ad8d3cb78527ac618f0a3994ac497cc35">SSID</ref>,<sp />WIFI_SSID,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(WIFI_SSID));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scan<sp />with<sp />the<sp />filter<sp />to<sp />obtain<sp />the<sp />security<sp />type.<sp />The<sp />function<sp />waits</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />until<sp />the<sp />security<sp />type<sp />is<sp />obtained<sp />in<sp />scan_to_get_security.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__wcm__functions_1gae0f0b5f3e6138bfdae943e9f7b16aa07">cy_wcm_start_scan</ref>(scan_to_get_security,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*)(&amp;security),<sp />&amp;scan_filter);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />xTaskNotifyWait(0,<sp />0,<sp />NULL,<sp />portMAX_DELAY);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memset(&amp;connect_param,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcy__wcm__connect__params__t">cy_wcm_connect_params_t</ref>));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memset(&amp;ip_address,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structcy__wcm__ip__address__t">cy_wcm_ip_address_t</ref>));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memcpy(connect_param.<ref kindref="member" refid="structcy__wcm__connect__params__t_1add927d1d5bbaf348296daad9a6312023">ap_credentials</ref>.<ref kindref="member" refid="structcy__wcm__ap__credentials__t_1aefb4693ca1fa808349032561a2e4b3bc">SSID</ref>,<sp />WIFI_SSID,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(WIFI_SSID));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memcpy(connect_param.<ref kindref="member" refid="structcy__wcm__connect__params__t_1add927d1d5bbaf348296daad9a6312023">ap_credentials</ref>.<ref kindref="member" refid="structcy__wcm__ap__credentials__t_1ad9ba797a8bc9bcb7708eb9b4560e3095">password</ref>,<sp />WIFI_PASSWORD,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(WIFI_PASSWORD));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />connect_param.<ref kindref="member" refid="structcy__wcm__connect__params__t_1add927d1d5bbaf348296daad9a6312023">ap_credentials</ref>.<ref kindref="member" refid="structcy__wcm__ap__credentials__t_1a576fbc5a934d7efe6c98e265678c38d9">security</ref><sp />=<sp />security;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Attempt<sp />to<sp />connect<sp />to<sp />Wi-Fi<sp />until<sp />a<sp />connection<sp />is<sp />made<sp />or<sp />until</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />MAX_WIFI_RETRY_COUNT<sp />attempts<sp />have<sp />been<sp />made.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(uint32_t<sp />conn_retries<sp />=<sp />0;<sp />conn_retries<sp />&lt;<sp />MAX_WIFI_RETRY_COUNT;<sp />conn_retries++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__wcm__functions_1ga9e8e04210ba0fc7429473d28d4643c7c">cy_wcm_connect_ap</ref>(&amp;connect_param,<sp />&amp;ip_address);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />==<sp />CY_RSLT_SUCCESS)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"Successfully<sp />connected<sp />to<sp />Wi-Fi<sp />network<sp />'%s'.\n"</highlight><highlight class="normal">,<sp />connect_param.<ref kindref="member" refid="structcy__wcm__connect__params__t_1add927d1d5bbaf348296daad9a6312023">ap_credentials</ref>.<ref kindref="member" refid="structcy__wcm__ap__credentials__t_1aefb4693ca1fa808349032561a2e4b3bc">SSID</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />event<sp />callbacks<sp />for<sp />changes<sp />in<sp />Wi-Fi<sp />link<sp />status.<sp />These</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />events<sp />could<sp />be<sp />related<sp />to<sp />IP<sp />address<sp />changes,<sp />connection,<sp />and</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />disconnection<sp />events.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__wcm__functions_1ga02f205b4d522c99d6c0b48f15683b0b6">cy_wcm_register_event_callback</ref>(network_event_callback);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"Connection<sp />to<sp />Wi-Fi<sp />network<sp />failed<sp />with<sp />error<sp />code<sp />%d."</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="stringliteral">"Retrying<sp />in<sp />%d<sp />ms...\n"</highlight><highlight class="normal">,<sp />(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal">)result,<sp />WIFI_CONN_RETRY_INTERVAL_MSEC);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />vTaskDelay(pdMS_TO_TICKS(WIFI_CONN_RETRY_INTERVAL_MSEC));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 4: Connect to Wi-Fi AP using WPS-Push Button</bold></para>
<para>This code snippet demonstrates joining a WPS AP and obtains its credentials through WPS using the push button mode. The credentials obtained are printed on the serial terminal.</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />The<sp />value<sp />of<sp />this<sp />macro<sp />specifies<sp />the<sp />maximum<sp />number<sp />of<sp />Wi-Fi<sp />networks<sp />the</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />device<sp />can<sp />join<sp />through<sp />WPS<sp />in<sp />one<sp />call<sp />to<sp />cy_wcm_wps_enrollee.<sp />This<sp />value<sp />is</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />2<sp />for<sp />dual<sp />band<sp />AP.<sp />Note<sp />that<sp />the<sp />device<sp />can<sp />obtain<sp />Wi-Fi<sp />credentials<sp />of<sp />only</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />one<sp />network<sp />and<sp />hence<sp />can<sp />receive<sp />a<sp />maximum<sp />of<sp />1<sp />for<sp />single<sp />band<sp />Wi-Fi<sp />AP<sp />or</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />2<sp />for<sp />dual<sp />band<sp />AP.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MAX_WIFI_CREDENTIALS_COUNT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Device's<sp />enrollee<sp />details.<sp />The<sp />details<sp />of<sp />WPS<sp />mode,<sp />WPS<sp />authentication,<sp />and</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />encryption<sp />methods<sp />supported<sp />are<sp />provided<sp />in<sp />this<sp />structure.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__wcm__wps__device__detail__t">cy_wcm_wps_device_detail_t</ref><sp />enrollee_details<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__wcm__wps__device__detail__t_1af691ce3681ce5c0307f43576271b61b8">device_name</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="stringliteral">"PSoC<sp />6"</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.manufacturer<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="stringliteral">"Cypress"</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.model_name<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="stringliteral">"PSoC<sp />6"</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.model_number<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="stringliteral">"1.0"</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.serial_number<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="stringliteral">"1234567"</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.device_category<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga2109f4415e7d9d586336f8c4415a270ea38c2c17db9981b8d58c56a03d9eea174">CY_WCM_WPS_DEVICE_COMPUTER</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.sub_category<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />7,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.config_methods<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggafef6a7e734e688418bfa6c601edf2cf1ace529442cbd31b83e4ac5a4b3ed33e0a">CY_WCM_WPS_CONFIG_LABEL</ref><sp />|<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggafef6a7e734e688418bfa6c601edf2cf1aaa30b78f42df81269f3c1b4e2cb8b563">CY_WCM_WPS_CONFIG_VIRTUAL_PUSH_BUTTON</ref><sp />|<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggafef6a7e734e688418bfa6c601edf2cf1aadb10bf953fe76e72cbf4dcddfbc38df">CY_WCM_WPS_CONFIG_VIRTUAL_DISPLAY_PIN</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.authentication_type_flags<sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggab50f2a67cec69a058057fc5fc6c5cea1a9936e971dccb38e7cf02448690e11359">CY_WCM_WPS_OPEN_AUTHENTICATION</ref><sp />|<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggab50f2a67cec69a058057fc5fc6c5cea1a97ad9d0d773ae0615f119a19c92b902e">CY_WCM_WPS_WPA_PSK_AUTHENTICATION</ref><sp />|<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggab50f2a67cec69a058057fc5fc6c5cea1a56f28a09b4389cd4b9a16e8d443c962a">CY_WCM_WPS_WPA2_PSK_AUTHENTICATION</ref><sp />|<sp /><ref kindref="member" refid="group__group__wcm__enums_1ggab50f2a67cec69a058057fc5fc6c5cea1a89ef5b1e77a439a54f7fae94a2b0dd87">CY_WCM_WPS_WPA2_WPA_PSK_MIXED_AUTHENTICATION</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.encryption_type_flags<sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga7ef358e8ada90c5a7d7a170d9c87f06fadecaa9e74027491e62c637b65f7f6cbd">CY_WCM_WPS_NO_ENCRYPTION</ref><sp />|<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga7ef358e8ada90c5a7d7a170d9c87f06fa03e109443caa4e7956944d22e3a00c36">CY_WCM_WPS_AES_ENCRYPTION</ref><sp />|<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga7ef358e8ada90c5a7d7a170d9c87f06fa8a6bf58d9350921fec4e196d35803a7d">CY_WCM_WPS_TKIP_ENCRYPTION</ref></highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_wcm_wps_pbc()</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />credentials<sp />obtained<sp />through<sp />WPS.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__wps__credential__t">cy_wcm_wps_credential_t</ref><sp />credentials[MAX_WIFI_CREDENTIALS_COUNT];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__wps__config__t">cy_wcm_wps_config_t</ref><sp />wps_config;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Stores<sp />the<sp />PIN<sp />used<sp />for<sp />WPS.<sp />It<sp />is<sp />unused<sp />when<sp />PBC<sp />mode<sp />is<sp />employed.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />pin_string[<ref kindref="member" refid="group__group__wcm__macros_1ga2fd33d6cf6472c7452a22e5988e69516">CY_WCM_WPS_PIN_LENGTH</ref>];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />credential_count<sp />=<sp />MAX_WIFI_CREDENTIALS_COUNT;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*Configure<sp />the<sp />mode<sp />of<sp />WPS<sp />as<sp />CY_WCM_WPS_PBC_MODE.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />wps_config.<ref kindref="member" refid="structcy__wcm__wps__config__t_1ad45eecaffb10e893f240bf42c05c453b">mode</ref><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga522893594393679bacaaaa77d81b26f8a31835b09070e6bd6c1728168e549c09c">CY_WCM_WPS_PBC_MODE</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />wps_config.<ref kindref="member" refid="structcy__wcm__wps__config__t_1ac9878359549a01538c7a9bcda83abde7">password</ref><sp />=<sp />pin_string;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memset(credentials,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(credentials));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"Press<sp />the<sp />push<sp />button<sp />on<sp />your<sp />WPS<sp />AP.\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__wcm__functions_1ga97e7212b4d3392a310682ff02f0d8d51">cy_wcm_wps_enrollee</ref>(&amp;wps_config,<sp />&amp;enrollee_details,<sp />credentials,<sp />&amp;credential_count);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_RSLT_SUCCESS<sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"WPS<sp />Success.\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Print<sp />the<sp />WPS<sp />credentials<sp />obtained<sp />through<sp />WPS.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(uint32_t<sp />loop<sp />=<sp />0;<sp />loop<sp />&lt;<sp />credential_count;<sp />loop++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"%ld.<sp />SSID<sp />=<sp />%s,<sp />Password<sp />=<sp />%c%c******.\n"</highlight><highlight class="normal">,<sp />loop<sp />+<sp />1,<sp />credentials[loop].ssid,<sp />credentials[loop].passphrase[0],<sp />credentials[loop].passphrase[1]);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 5: Connect to Wi-Fi AP using WPS-Pin</bold></para>
<para>This code snippet demonstrates joining a WPS AP and obtains its credentials through WPS using the PIN mode. The credentials obtained are printed on the serial terminal</para><para><programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_wcm_wps_pin()</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />cy_rslt_t<sp />result;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__wps__credential__t">cy_wcm_wps_credential_t</ref><sp />credentials[MAX_WIFI_CREDENTIALS_COUNT];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__wcm__wps__config__t">cy_wcm_wps_config_t</ref><sp />wps_config;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />pin_string[<ref kindref="member" refid="group__group__wcm__macros_1ga2fd33d6cf6472c7452a22e5988e69516">CY_WCM_WPS_PIN_LENGTH</ref>];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />credential_count<sp />=<sp />MAX_WIFI_CREDENTIALS_COUNT;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />memset(credentials,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(credentials));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Here,<sp />the<sp />WPS<sp />PIN<sp />is<sp />generated<sp />by<sp />the<sp />device.<sp />the<sp />user<sp />has<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />enter<sp />the<sp />pin<sp />in<sp />the<sp />AP<sp />to<sp />join<sp />the<sp />network<sp />through<sp />WPS.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__wcm__functions_1ga0369189fc2845efdf57cd3ce9b0d188e">cy_wcm_wps_generate_pin</ref>(pin_string);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*Configure<sp />the<sp />mode<sp />of<sp />WPS<sp />as<sp />CY_WCM_WPS_PIN_MODE.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />wps_config.<ref kindref="member" refid="structcy__wcm__wps__config__t_1ad45eecaffb10e893f240bf42c05c453b">mode</ref><sp />=<sp /><ref kindref="member" refid="group__group__wcm__enums_1gga522893594393679bacaaaa77d81b26f8a95b8f9041290279c8c309fa985241565">CY_WCM_WPS_PIN_MODE</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />wps_config.<ref kindref="member" refid="structcy__wcm__wps__config__t_1ac9878359549a01538c7a9bcda83abde7">password</ref><sp />=<sp />pin_string;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"Enter<sp />this<sp />PIN:<sp />\'%s\'<sp />in<sp />your<sp />AP.\n"</highlight><highlight class="normal">,<sp />pin_string);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__wcm__functions_1ga97e7212b4d3392a310682ff02f0d8d51">cy_wcm_wps_enrollee</ref>(&amp;wps_config,<sp />&amp;enrollee_details,<sp />credentials,<sp />&amp;credential_count);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(CY_RSLT_SUCCESS<sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"WPS<sp />Success.\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Print<sp />the<sp />WPS<sp />credentials<sp />obtained<sp />through<sp />WPS.*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(uint32_t<sp />loop<sp />=<sp />0;<sp />loop<sp />&lt;<sp />credential_count;<sp />loop++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf(</highlight><highlight class="stringliteral">"%ld.<sp />SSID<sp />=<sp />%s,<sp />Password<sp />=<sp />%c%c******.\n"</highlight><highlight class="normal">,<sp />loop<sp />+<sp />1,<sp />credentials[loop].ssid,<sp />credentials[loop].passphrase[0],<sp />credentials[loop].passphrase[1]);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>